> For the complete documentation index, see [llms.txt](https://docs.intrepidcs.com/vspy-3-documentation/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.intrepidcs.com/vspy-3-documentation/vehicle-spy-main-menus/main-menu-scripting-and-automation/application-signals.md).

# Application Signals

Application signals store values in Vehicle Spy. They can hold values set by the user or be calculated signals that are not necessarily derived from network messaging. For example, a signal could be created where the value changes as if a function generator were attached to it. Application signals are setup under Scripting and Automation -> Application Signals. Vehicle Spy supports [analog](/vspy-3-documentation/shared-features-in-vehicle-spy/shared-features-calculated-signal-editor/shared-features-calculated-analog-or-digital-signals.md), [digital](/vspy-3-documentation/shared-features-in-vehicle-spy/shared-features-calculated-signal-editor/shared-features-calculated-analog-or-digital-signals.md), state encoded, and [text](/vspy-3-documentation/shared-features-in-vehicle-spy/shared-features-calculated-signal-editor/shared-features-calculated-text-signals.md) type application signals.\
\
The left half of the Application Signals window is used to add, delete, and select application signals. Enter text in the Filter field to display only the application signal descriptions containing that text. Leave the Filter blank to display all application signals.\
\
Figure 1 shows the right half of the Application Signals window. The upper section ![](https://cdn.intrepidcs.net/support/VehicleSpy/assets/smOne.gif) defines the application signal by giving it a name and a type. The [Format and Units](/vspy-3-documentation/vehicle-spy-main-menus/main-menu-spy-networks/message-editor/message-signals/message-signal-format-and-units.md) fields ![](https://cdn.intrepidcs.net/support/VehicleSpy/assets/smTwo.gif) are used in the same way as for building Message Signals. The checkbox at location ![](https://cdn.intrepidcs.net/support/VehicleSpy/assets/smThree.gif) gives the option to create an application array. Application signal arrays work in a similar manner as with other programming languages. The Array Size determines how many elements are in the group. Each element is accessed by using an index number 0 to one less than the Array Size.\
\
You have a few options in the Value Type area that define when the signal is calculated.\
\
**This value is used as a general purpose variable** ![](https://cdn.intrepidcs.net/support/VehicleSpy/assets/smFour.gif): This option is used when values are to be assigned in other parts of Vehicle Spy like function blocks. The Initial Value option will set the application signal to the specified value when Start is clicked in Vehicle Spy.\
\
**This value is calculated on an interval** ![](https://cdn.intrepidcs.net/support/VehicleSpy/assets/smFive.gif): Using this option, the application signal is calculated on a predefined interval. Click the Setup button to define the calculation with the [Calculated Signal Editor](/vspy-3-documentation/shared-features-in-vehicle-spy/shared-features-calculated-signal-editor.md).\
\
**This value is a timer** ![](https://cdn.intrepidcs.net/support/VehicleSpy/assets/smSix.gif): This option can increment or decrement the value of an application signal in millisecond or microsecond increments.

![Figure 1: The right half of the Application Signals window provides many setup options.](/files/iLs1QHtpJTiDeThpHgws)

**Other options**![](https://cdn.intrepidcs.net/support/VehicleSpy/assets/smSeven.gif): The Text API Save and Restore option gives a way to save application signals to the PC. Click [here](/vspy-3-documentation/vehicle-spy-main-menus/main-menu-scripting-and-automation/application-signals/application-signals-save-and-restore.md) for more help regarding how to save and restore application signals. The Persistent Signals option is used when working with CoreMini. When enabled, application signals are saved to the SD card keeping signal values over power cycles. The final option is to never optimize the signals out even is unused. This option is for VehicleScape DAQ and is used for internal values. To help track down where application signals are used in a setup, quick find buttons![](https://cdn.intrepidcs.net/support/VehicleSpy/assets/smEight.gif) are available. The quick find buttons will hunt down applications signals used in Graphical panels and C Code interface. Click the corresponding button to search that section of Vehicle Spy.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.intrepidcs.com/vspy-3-documentation/vehicle-spy-main-menus/main-menu-scripting-and-automation/application-signals.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
